//
//  ContentView.swift
//  Deliverable 1
//
//  Created by Sneh Kothari on 17/09/22.
//

import SwiftUI
import RealityKit
import ARKit

struct ContentView : View {
    let arViewContainer = ARWorldViewContainer(placeObjectView: PlaceObjectController(frame: .zero))
    var body: some View {
        ZStack {
            RoomView(arViewContainer: arViewContainer)
//            VStack {
//                Spacer()
//                Text("One shoe already present cannot add more")
//                    .font(.title2)
//                    .bold()
//            }.background(.clear)
//                .isHidden(showAlert.main.showingAlert)
//                .onChange(of: showAlert.main.showingAlert){_ in
//                    print(showAlert.main.showingAlert)
//                    if showAlert.main.showingAlert {
//                        DispatchQueue.main.asyncAfter(deadline: DispatchTime.now() + 10) {
//                            showAlert.main.showingAlert.toggle()
//                        }
//                    }
//                }
        }.id(showAlert.main.showingAlert)
    }
}



#if DEBUG
struct ContentView_Previews : PreviewProvider {
    static var previews: some View {
        ContentView()
    }
}
#endif

//struct ARViewContainer: UIViewRepresentable {
//    let placeObjectView = PlaceObjectController(frame: .zero)
//    func makeUIView(context: Context) -> ARView {
//
//        let arView = placeObjectView
//        return arView
//
//    }
//
//    func updateUIView(_ uiView: ARView, context: Context) {}
//
//}
struct ARWorldViewContainer: UIViewRepresentable {
    let placeObjectView: PlaceObjectController
    func makeUIView(context: Context) -> ARView {
        let config = ARWorldTrackingConfiguration()
        config.planeDetection = [.horizontal]
        config.environmentTexturing = .automatic
//        let map = try! arWorldMap.loadWorldMap()
//        config.initialWorldMap = map
        let arView = placeObjectView
        arView.session.run(config, options: [.resetTracking, .removeExistingAnchors])
        return arView
    }
    
    func updateUIView(_ uiView: ARView, context: Context) {}
}
