//
//  RoomMapper.swift
//  Deliverable 1
//
//  Created by Sneh Kothari on 19/09/22.
//

import Foundation
import RealityKit
import ARKit

class RoomMapper: ObservableObject {
    @Published var roomName = "New Room"
    @Published var maxRoomCount = 1
    @Published var id = 1
    init() {
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    var worldMapURL: URL = {
        do {
            return try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: true)
                .appendingPathComponent("worldMapURL")
        } catch {
            fatalError("Error getting world map URL from document directory.")
        }
    }()
    
    func writeWorldMap(_ worldMap: ARWorldMap) throws {
        let url = "Room\(maxRoomCount)"
        var rooms = UserDefaults.standard.stringArray(forKey: "room") ?? []
        rooms.append(url)
        UserDefaults.standard.setValue(rooms, forKey: "room")
        let data = try NSKeyedArchiver.archivedData(withRootObject: worldMap, requiringSecureCoding: false)
        UserDefaults.standard.set(data, forKey: rooms[rooms.count - 1])
    }
    
    func loadWorldMap() throws -> ARWorldMap {
        let mapData = UserDefaults.standard.data(forKey: roomName)!
        print(mapData)
        guard let worldMap = try NSKeyedUnarchiver.unarchivedObject(ofClass: ARWorldMap.self, from: mapData)
            else {
            print("ERROR")
            throw ARError(.invalidWorldMap) }
        print("PPPPPP")
        print(worldMap)
        return worldMap
    }
}
